#!/bin/bash

set -eu

fatal() {
	echo "$1" >&2
	exit 1
}

machinelist() {
	machinectl | tail -n +2 | head -n -2 | cut -d' ' -f1
}

main() {

	local machinename="$1"
	local expect_regex='^tmp\...........$'

	if [[ "$machinename" =~ $expect_regex ]] ; then

		if machinelist | grep -q "$machinename" ; then
			machinectl terminate "$machinename"
			# n.b. TOCTTOU vulnerability

		else
			fatal "not running"
		fi
	else
		fatal "bad name"
	fi

}

main "$@"
