<?php

/**
 * Check whether a local path is a valid appdata zip file.
 *
 * @param string $filepath Path to file
 * @return boolean|string  True, or error string
 */
function paas__validate($filepath) {
	$z = new ZipArchive();

	if ($z->open($filepath) !== true) {
		return "Couldn't read ZIP format.";
	}
	
	if ($z->locateName('start') === false) {
		return "ZIP archive missing 'start' file.";
	}
	
	return true; // LGTM
}

function paas__start($appdata_id) {
	
	// Write to file
	
	$data = DB::appdata_getdata($appdata_id);
	if ($data === false) {
		return false;
	}
	
	$tmpfile = trim(`mktemp`);
	file_put_contents($tmpfile, $data);
	
	// Start, and record the fact
	
	$localpath = trim(shell_exec('sudo /opt/paas/paas-runapp.sh '.escapeshellarg($tmpfile)));
	
	DB::running_start($appdata_id, $localpath);
	
	// Tempfile will be cleaned up by paas script
}

function paas__kill($machine_dirname) {
	
	$rpos = strrpos($machine_dirname, '/');
	if ($rpos === false) {
		return false;
	}
	
	$machine_name = substr($machine_dirname, $rpos + 1);
	
	shell_exec('sudo /opt/paas/paas-killapp.sh '.escapeshellarg($machine_name));
	
	// Log files and DB will be cleaned up by paas script
	
	sleep(2); // arbitrary delay before returning to the UI
	
	return true;
}
